#!/bin/bash
# Copyright (c) Limulus Computing, Basement Supercomputing 2020
if [ ! -e  ~/.ssh ];
then
  /usr/bin/ssh-keygen  -q -t ecdsa -b 521  -f ~/.ssh/id_ecdsa  -N ''
  if [ "$?" -ne "0" ];
  then
    printf "The following SSH Key generation command failed:
     /usr/bin/ssh-keygen  -q ecdsa -b 521  -f ~/.ssh/id_ecdsa  -N ''"
     exit 1 
  fi
  /bin/cp ~/.ssh/id_ecdsa.pub ~/.ssh/authorized_keys
  if [ "$?" -ne "0" ];
  then
    printf "The following command failed:
     /bin/cp ~/.ssh/id_ecdsa.pub ~/.ssh/authorized_keys"
     exit 1
  fi
  printf "SSH keys generated for your account.\n"
fi
#remove the line that calls this script from users .bashrc and .cshrc in all cases.
# i.e. removes it even it the first part of the script fails, this is a one trick pony
if [  -e  ~/.bashrc ];
then
  sed --in-place '/\/etc\/warewulf\/\.Limulus\/generate-ssh-keys\.sh/d' ~/.bashrc
fi
if [  -e  ~/.cshrc ];
then
  sed --in-place '/\/etc\/warewulf\/\.Limulus\/generate-ssh-keys\.sh/d' ~/.cshrc
fi
exit 0
